#include<stdio.h>
#include<stdlib.h>
#include<fcntl.h>
#include <asm/ioctl.h>

#define DEVICE_PATH				"/dev/my_device"
/* #define IOCTL_IN _IOC(_IOC_WRITE, 'k', 1, sizeof(my_ioctl_data)) */
#define MY_IOCTL_IN _IOC(_IOC_WRITE, 'k', 1, 0)


//prints error message and exits
void error(char* message) {
	fprintf(stderr,"%s\n",message);
	exit(1);
}

//usage: ./control i / r / w
int main(int argc, char** argv) {
	int fd;
	
	if(argc!=2) {
		printf("Usage: ./control <option>\n option: \n\ti - ioctl\n\tr - read\n\t"
			   "w - write\n\n");
		exit(1);
	}
	
	if((fd = open(DEVICE_PATH,O_RDWR)) < 0) 
		error("Error opening device\n");

	switch(argv[1][0]) {
	case 'i':												//ioctl
		printf("Ioctl\n");
		if(ioctl(fd,MY_IOCTL_IN) < 0)
			error("Ioctl error\n");
		break;	
	case 'r':												//read
		printf("Read\n");
		if(read(fd, NULL, 0) < 0)
			error("Read error\n");
		break;	
	case 'w':												//write
		printf("Write\n");
		if(write(fd, NULL, 0) < 0)
		    error("Write error\n");
		break;	
	default:
		error("Wrong parameter\n");
	}

	close(fd);
	return 0;
}
